%define __check_files %{nil}

%define vendor_name     hde
%define target          rrdtool
%define _name           %{vendor_name}-%{target}

%define _prefix         /opt/%{vendor_name}
%define _bindir         %{_prefix}/bin
%define _sbindir        %{_prefix}/sbin
%ifarch x86_64 ia64
%define _libdir         %{_prefix}/lib64
%else
%define _libdir         %{_prefix}/lib
%endif
%define _includedir     %{_prefix}/include
%define _datadir        %{_prefix}/share
%define _defaultdocdir  %{_datadir}/doc/packages
%define _infodir        %{_datadir}/info
%define _mandir         %{_datadir}/man

%define _logdir         /var/log/%{_name}
%define _localstatedir  /var
%define _sysconfdir     /etc%{_prefix}

%define python_sitelib  %{_prefix}/lib/python
%define python_sitearch %{_prefix}/lib/python

%define contentdir /var%{_prefix}/rrdcached

%define perl_vendorarch %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)
%define perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)

Summary: Round Robin Database Tool to store and display time-series data
Name: %{_name}
Version: 1.4.4
Release: 1
License: GPL
Group: Applications/Databases
URL: http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/

Packager: Taizo ITO <taizo@karesansui-project.info>
Vendor: Karesansui Project

Source0: http://oss.oetiker.ch/rrdtool/pub/rrdtool-%{version}.tar.gz
Source1: rrdcached.init
Source2: rrdcached.sysconf
Patch0: rrdtool-1.4.3-rrd_graph_c.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: freetype-devel, gcc-c++, libpng-devel, libxml2-devel, openssl-devel
BuildRequires: python-devel >= 2.3
BuildRequires: zlib-devel, gettext-devel
BuildRequires: intltool >= 0.35.0, make

Requires: libxml2, openssl, python, zlib, gettext
Requires: perl >= %(rpm -q --qf '%%{epoch}:%%{version}' perl)
Requires: initscripts >= 8.36

Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv
Prereq: sh-utils, textutils, /usr/sbin/useradd

BuildRequires: pango-devel
BuildRequires: cairo-devel
BuildRequires: glib2-devel
#BuildRequires: xulrunner-devel
Requires: pango
Requires: cairo
Requires: glib2


%description
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). It stores the data in a very compact way that will not
expand over time, and it presents useful graphs by processing the data to
enforce a certain data density. It can be used either via simple wrapper
scripts (from shell or Perl) or via frontends that poll network devices and
put a friendly user interface on it.

%package devel
Summary: RRDtool static libraries and header files
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). This package allow you to use directly this library.

%package -n %{name}-perl
Summary: Perl RRDtool bindings
Group: Development/Languages
Requires: %{name} = %{version}
Obsoletes: rrdtool-perl <= %{version}-%{release}
Provides: rrdtool-perl = %{version}-%{release}

%description -n %{name}-perl
The Perl RRDtool bindings

%package -n %{name}-python
Summary: Python RRDtool bindings
Group: Development/Languages
BuildRequires: python
Requires: python >= 2.4
Requires: %{name} = %{version}

%description -n %{name}-python
Python RRDtool bindings.

%prep
%if 0%{?el4}
# Filter auto-requires for pango
cat > find-requires-%{name} <<EOT
#!/bin/sh
%{__find_requires} | grep -v 'pango'
exit 0
EOT
chmod 755 find-requires-%{name}
%define __find_requires %{_builddir}/find-requires-%{name}
%define _use_internal_dependency_generator 0
%endif

%setup -n %{target}-%{version}
%patch0 -p1

%build
%if 0%{?el4}
export CFLAGS="`pkg-config --cflags cairo pangocairo pango pangoft2`"
export LDFLAGS="`pkg-config --libs  cairo pangocairo pango pangoft2`"
%endif

%configure \
    --with-perl-options='INSTALLDIRS="vendor"' \
    --disable-ruby-site-install
#    --disable-mmap
  
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR="%{buildroot}" INSTALLVENDORMAN3DIR="%{_mandir}/man3"

pushd bindings/python/
python setup.py install --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES --home=%{_prefix} --install-lib %{python_sitearch}
popd

find %{buildroot} -name .packlist -exec %{__rm} {} \;
%{__rm} -f %{buildroot}%{perl_archlib}/perllocal.pod
%{__rm} -f %{buildroot}%{perl_vendorarch}/ntmake.pl

# put rrdcached in its proper place
%{__mkdir} -p %{buildroot}%{_sbindir}
%{__mv} -f %{buildroot}%{_bindir}/rrdcached %{buildroot}%{_sbindir}/rrdcached

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/rrdcached.init \
        $RPM_BUILD_ROOT/etc/rc.d/init.d/hde-rrdcached
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
        $RPM_BUILD_ROOT/etc/rc.d/init.d/hde-rrdcached

# install conf file/directory
mkdir $RPM_BUILD_ROOT/etc/sysconfig
install -m 644 $RPM_SOURCE_DIR/rrdcached.sysconf \
   $RPM_BUILD_ROOT/etc/sysconfig/hde-rrdcached

# make the proper /var directories
mkdir -p $RPM_BUILD_ROOT/var/run/hde-rrdcached
mkdir -p $RPM_BUILD_ROOT/var/lib/hde-rrdcached

mkdir -p $RPM_BUILD_ROOT%{contentdir}

%pre
# Add the "rrdcache" user
/usr/sbin/useradd -c "hde-rrdcache" -u 98 \
        -s /sbin/nologin -r -d %{contentdir} hde-rrd 2> /dev/null || :


%post
# Register the rrdcached service
/sbin/chkconfig --add hde-rrdcached
/sbin/chkconfig hde-rrdcached off


%preun
if [ $1 = 0 ]; then
        /sbin/service hde-rrdcached stop > /dev/null 2>&1
        /sbin/chkconfig --del hde-rrdcached
fi


%clean
%{__rm} -rf %{buildroot}
%if 0%{?el4}
%{__rm} -f %{_builddir}/find-requires-%{name}
%endif


%files
%defattr(-, root, root, 0755)
%doc CHANGES CONTRIBUTORS COPYING COPYRIGHT NEWS README THREADS TODO
%doc %{_mandir}/man1/*.1
%doc %{_mandir}/man3/*.3
%{_bindir}/rrdcgi
%{_bindir}/rrdtool
%{_bindir}/rrdupdate
%{_sbindir}/rrdcached
%{_libdir}/librrd.so.*
%{_libdir}/librrd_th.so.*
#%{_libdir}/librrd.a
#%{_libdir}/librrd_th.a
#%{_datadir}/rrdtool/

%config(noreplace) /etc/sysconfig/hde-rrdcached
%config /etc/rc.d/init.d/hde-rrdcached

%attr(0755,hde-rrd,hde-rrd) %dir /var/run/hde-rrdcached
%attr(0755,hde-rrd,hde-rrd) %dir %{contentdir}


%files devel
%defattr(-, root, root, 0755)
%{_includedir}/rrd.h
%{_includedir}/rrd_client.h
%{_includedir}/rrd_format.h
%{_libdir}/librrd.a*
%{_libdir}/librrd_th.a*
%{_libdir}/pkgconfig/librrd.pc
%{_libdir}/librrd.la*
%{_libdir}/librrd_th.la*
#%exclude %{_libdir}/librrd.la
#%exclude %{_libdir}/librrd_th.la

%files -n %{name}-perl
%defattr(-, root, root, 0755)
%doc bindings/perl-shared/MANIFEST bindings/perl-shared/README
%doc examples/ 
%doc %{_mandir}/man3/*.3pm
%{perl_vendorarch}/RRDs.pm
%{perl_vendorarch}/auto/RRDs/*
%{perl_vendorlib}/RRDp.pm

%files -n %{name}-python
%defattr(-, root, root, 0755)
%doc bindings/python/ACKNOWLEDGEMENT bindings/python/AUTHORS bindings/python/COPYING bindings/python/README
%{python_sitearch}/rrdtoolmodule.so

%changelog
* Wed Jul 7 2010 Taizo ITO <taizo@karesansui-project.info> - 1.4.4-1
- update version.

* Mon May 17 2010 Kei Funagayama <kei@karesansui-project.info> - 1.4.3-2
- LOGO clear.
- Titles displayed in left-justified

* Mon Mar 29 2010 Taizo ITO <taizo@karesansui-project.info> - 1.4.3-1
- 1.4.3

* Mon Jan 25 2010 Taizo ITO <taizo@karesansui-project.info> - 1.4.2-1
- 1.4.2

